package ecs.exam2018;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetSocketAddress;
import java.net.SocketException;
import java.net.SocketTimeoutException;

public class UDPDiscoverRegistry {
  private DatagramSocket serverSocket;

  public UDPDiscoverRegistry () {};/*@ init @*/
  public void launchClient(String ip) {//(* \ldots *)}
    /*@ skip @*/ }  /*@ main @*/
  public void waitForServer() {
    try {
      DatagramSocket serverSocket = new DatagramSocket(null);
      // (*\circled{6}*) /*@ after6 @*/
      serverSocket.bind(new InetSocketAddress(10000));
      serverSocket.setSoTimeout(1000);
      byte buffer[] = new byte[128];
      DatagramPacket packet = new DatagramPacket(buffer, 128);
      int retries = 10;
      /*@ beforewhile @*/
      while (true) {
        try {
          // (*\circled{7}*)          /*@ inwhile @*/


          serverSocket.receive(packet);
          String received = new String(packet.getData(), packet.getOffset(), packet.getLength());
          String [] args = received.split(":");
          launchClient(args[1]);
          return;
          /*@ endwhile @*/
        } catch (SocketTimeoutException e) {
          // (*\circled{8}*) /*@ incatch @*/
          retries--;
          if (retries == 0) return;
          /*@ endcatch @*/
        }
      }
    } catch (Exception e) {}
  } /*@ endmethod @*/
}
